searchNodes=[{"doc":"Responsible for managing multiple connections for a single cluster, routing requests accordingly, and enforcing Well-behaved praticies.","ref":"RabbitMQStream.html","title":"RabbitMQStream","type":"module"},{"doc":"Responsible for encoding and decoding messages, opening and maintaining a socket connection to a single node. It connects to the RabbitMQ, and authenticates, and mantains the connection open with heartbeats. Adding a connectiong to the supervision tree You can define a connection with: defmodule MyApp.MyConnection use RabbitMQStream.Connection end Then you can add it to your supervision tree: def start ( _ , _ ) do children = [ { MyApp.MyConnection , username : &quot;guest&quot; , password : &quot;guest&quot; , host : &quot;localhost&quot; , vhost : &quot;/&quot; } } , # ... ] opts = # ... Supervisor . start_link ( children , opts ) end Connection configuration The connection accept the following options: username - The username to use for authentication. Defaults to guest . password - The password to use for authentication. Defaults to guest . host - The host to connect to. Defaults to localhost . port - The port to connect to. Defaults to 5552 . vhost - The virtual host to use. Defaults to / . frame_max - The maximum frame size in Bytes. Defaults to 1_048_576 . heartbeat - The heartbeat interval in seconds. Defaults to 60 . lazy - If true , the connection won't starting until explicitly calling connect/1 . Defaults to false . Subscribing to messages You can subscribe to messages by calling subscribe/5 : { :ok , _subscription_id } = MyApp.MyConnection . subscribe ( &quot;stream-01&quot; , self ( ) , :next , 999 )","ref":"RabbitMQStream.Connection.html","title":"RabbitMQStream.Connection","type":"behaviour"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:close/2","title":"RabbitMQStream.Connection.close/2","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:connect/0","title":"RabbitMQStream.Connection.connect/0","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:create_stream/2","title":"RabbitMQStream.Connection.create_stream/2","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:declare_publisher/2","title":"RabbitMQStream.Connection.declare_publisher/2","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:delete_publisher/1","title":"RabbitMQStream.Connection.delete_publisher/1","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:delete_stream/1","title":"RabbitMQStream.Connection.delete_stream/1","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:publish/3","title":"RabbitMQStream.Connection.publish/3","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:query_metadata/1","title":"RabbitMQStream.Connection.query_metadata/1","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:query_offset/2","title":"RabbitMQStream.Connection.query_offset/2","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:query_publisher_sequence/2","title":"RabbitMQStream.Connection.query_publisher_sequence/2","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:start_link/1","title":"RabbitMQStream.Connection.start_link/1","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:store_offset/3","title":"RabbitMQStream.Connection.store_offset/3","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:subscribe/5","title":"RabbitMQStream.Connection.subscribe/5","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#c:unsubscribe/1","title":"RabbitMQStream.Connection.unsubscribe/1","type":"callback"},{"doc":"","ref":"RabbitMQStream.Connection.html#t:connection_option/0","title":"RabbitMQStream.Connection.connection_option/0","type":"type"},{"doc":"","ref":"RabbitMQStream.Connection.html#t:connection_options/0","title":"RabbitMQStream.Connection.connection_options/0","type":"type"},{"doc":"","ref":"RabbitMQStream.Connection.html#t:offset/0","title":"RabbitMQStream.Connection.offset/0","type":"type"},{"doc":"","ref":"RabbitMQStream.Connection.html#t:t/0","title":"RabbitMQStream.Connection.t/0","type":"type"},{"doc":"RabbitMQStream.Publisher allows you to define modules or processes that publish messages to a single stream. Defining a publisher Module A standalone publisher module can be defined with: defmodule MyApp.MyPublisher do use RabbitMQStream.Publisher , stream_name : &quot;my-stream&quot; , connection : MyApp.MyConnection end After adding it to your supervision tree, you can publish messages with: MyApp.MyPublisher . publish ( &quot;Hello, world!&quot; ) You can add the publisher to your supervision tree as follows this: def start ( _ , _ ) do children = [ # ... MyApp.MyPublisher ] opts = # ... Supervisor . start_link ( children , opts ) end The standalone publisher starts its own RabbitMQStream.Connection , declaring itself and fetching its most recent publishing_id , and declaring the stream, if it does not exist. Configuration The RabbitMQStream.Publisher accepts the following options: stream_name - The name of the stream to publish to. Required. reference_name - The string which is used by the server to prevent Duplicate Message . Defaults to __MODULE__.Publisher . connection - The identifier for a RabbitMQStream.Connection .","ref":"RabbitMQStream.Publisher.html","title":"RabbitMQStream.Publisher","type":"module"},{"doc":"","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"First add RabbitMQ to your mix.exs dependencies: def deps do [ { :rabbitmq_stream , &quot;~&gt; 0.1.0&quot; } , # ... ] end","ref":"getting-started.html#installation","title":"Getting Started - Installation","type":"extras"},{"doc":"First you define a connection defmodule MyApp.MyConnection use RabbitMQStream.Connection end Then you can subscribe to messages from a stream: { :ok , _subscription_id } = MyApp.MyConnection . subscribe ( &quot;stream-01&quot; , self ( ) , :next , 999 )","ref":"getting-started.html#subscribing-to-stream","title":"Getting Started - Subscribing to stream","type":"extras"},{"doc":"RabbitMQ Streams protocol needs a static :reference_name per publisher. This is used to prevent message duplication. For this reason, each stream needs, for now, a static module to publish messages, which keeps track of its own publishing_id . You can define a Publisher module like this: defmodule MyApp.MyPublisher use RabbitMQStream.Publisher , stream : &quot;stream-01&quot; , connection : MyApp.MyConnection end Then you can publish messages to the stream: MyApp.MyPublisher . publish ( &quot;Hello World&quot; )","ref":"getting-started.html#publishing-to-stream","title":"Getting Started - Publishing to stream","type":"extras"},{"doc":"Under construction","ref":"publishing.html","title":"Publishing Messages","type":"extras"},{"doc":"Under construction","ref":"connection.html","title":"Using Connection","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Initial Hex Publishing.","ref":"changelog.html#0-0-1","title":"Changelog - 0.0.1","type":"extras"}]